diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/metadata/ciff.cpp libkdcraw/libkdcraw/libraw/src/metadata/ciff.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/metadata/ciff.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/metadata/ciff.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,416 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+#ifdef _MSC_VER
+#if _MSC_VER < 1800 /* below MSVC 2013 */
+float roundf(float f)
+{
+ return floorf(f + 0.5);
+}
+
+#endif
+#endif
+
+/*
+   CIFF block 0x1030 contains an 8x8 white sample.
+   Load this into white[][] for use in scale_colors().
+ */
+void LibRaw::ciff_block_1030()
+{
+  static const ushort key[] = {0x410, 0x45f3};
+  int i, bpp, row, col, vbits = 0;
+  unsigned long bitbuf = 0;
+
+  if ((get2(), get4()) != 0x80008 || !get4())
+    return;
+  bpp = get2();
+  if (bpp != 10 && bpp != 12)
+    return;
+  for (i = row = 0; row < 8; row++)
+    for (col = 0; col < 8; col++)
+    {
+      if (vbits < bpp)
+      {
+        bitbuf = bitbuf << 16 | (get2() ^ key[i++ & 1]);
+        vbits += 16;
+      }
+      white[row][col] = bitbuf >> (vbits -= bpp) & ~(-1 << bpp);
+    }
+}
+
+/*
+   Parse a CIFF file, better known as Canon CRW format.
+ */
+void LibRaw::parse_ciff(int offset, int length, int depth)
+{
+  int tboff, nrecs, c, type, len, save, wbi = -1;
+  ushort key[] = {0x410, 0x45f3};
+  ushort CanonColorInfo1_key;
+  ushort Appendix_A = 0;
+  INT64 WB_table_offset = 0;
+  int UseWBfromTable_as_AsShot = 1;
+  int Got_AsShotWB = 0;
+  INT64 fsize = ifp->size();
+  if (metadata_blocks++ > LIBRAW_MAX_METADATA_BLOCKS)
+    throw LIBRAW_EXCEPTION_IO_CORRUPT;
+
+  fseek(ifp, offset + length - 4, SEEK_SET);
+  tboff = get4() + offset;
+  fseek(ifp, tboff, SEEK_SET);
+  nrecs = get2();
+  if (nrecs < 1)
+    return;
+  if ((nrecs | depth) > 127)
+    return;
+
+  if (nrecs * 10 + offset > fsize)
+    return;
+
+  while (nrecs--)
+  {
+    type = get2();
+    len = get4();
+    INT64 see = offset + get4();
+    save = ftell(ifp);
+
+    /* the following tags are not sub-tables
+     * they contain the value in the "len" field
+     * for such tags skip the check against filesize
+     */
+    if ((type != 0x2007) && (type != 0x580b) && (type != 0x501c) &&
+        (type != 0x5029) && (type != 0x5813) && (type != 0x5814) &&
+        (type != 0x5817) && (type != 0x5834) && (type != 0x580e))
+    {
+
+      if (see >= fsize)
+      { // At least one byte
+        fseek(ifp, save, SEEK_SET);
+        continue;
+      }
+      fseek(ifp, see, SEEK_SET);
+      if ((((type >> 8) + 8) | 8) == 0x38)
+      {
+        parse_ciff(ftell(ifp), len, depth + 1); /* Parse a sub-table */
+      }
+    }
+
+    if (type == 0x3004)
+    {
+      parse_ciff(ftell(ifp), len, depth + 1);
+    }
+    else if (type == 0x0810)
+    {
+      fread(artist, 64, 1, ifp);
+    }
+    else if (type == 0x080a)
+    {
+      fread(make, 64, 1, ifp);
+      fseek(ifp, strbuflen(make) - 63, SEEK_CUR);
+      fread(model, 64, 1, ifp);
+
+    } else if (type == 0x080b) {
+      char *p;
+      stmread(imCommon.firmware, (unsigned)len, ifp);
+      if (p = strrchr(imCommon.firmware, ' ')) {
+        imCanon.firmware = atof(p+1);
+      }
+
+    } else if (type == 0x1810)
+    {
+      width = get4();
+      height = get4();
+      pixel_aspect = int_to_float(get4());
+      flip = get4();
+    }
+    else if (type == 0x1835)
+    { /* Get the decoder table */
+      tiff_compress = get4();
+    }
+    else if (type == 0x2007)
+    {
+      thumb_offset = see;
+      thumb_length = len;
+    }
+    else if (type == 0x1818)
+    {
+      shutter = libraw_powf64l(2.0f, -int_to_float((get4(), get4())));
+      ilm.CurAp = aperture = libraw_powf64l(2.0f, int_to_float(get4()) / 2);
+    }
+    else if (type == 0x102a) // CanonShotInfo
+    {
+      //      iso_speed = pow (2.0, (get4(),get2())/32.0 - 4) * 50;
+      get2(); // skip one
+      iso_speed =
+          libraw_powf64l(2.0f, (get2() + get2()) / 32.0f - 5.0f) * 100.0f;
+      ilm.CurAp = aperture = _CanonConvertAperture((get2(), get2()));
+      shutter = libraw_powf64l(2.0, -((short)get2()) / 32.0);
+      imCanon.wbi = wbi = (get2(), get2());
+      if (wbi >= Canon_wbi2std.size())
+        wbi = 0;
+      fseek(ifp, 32, SEEK_CUR);
+      if (shutter > 1e6)
+        shutter = get2() / 10.0;
+    }
+    else if (type == 0x102c) // CanonColorInfo2 / Appendix A: Pro90IS, G1, G2, S30, S40
+    {
+      int CanonColorInfo2_type = get2(); // G1 1028, G2 272, Pro90 IS 769, S30 274, S40 273, EOS D30 276
+      if (CanonColorInfo2_type > 512) { /* Pro90 IS, G1 */
+        fseek(ifp, 118, SEEK_CUR);
+        FORC4 cam_mul[BG2RG1_2_RGBG(c)] = get2();
+      }
+      else if (CanonColorInfo2_type != 276) { /* G2, S30, S40 */
+        Appendix_A = 1;
+        WB_table_offset = -14;
+        fseek(ifp, 98, SEEK_CUR);
+        FORC4 cam_mul[GRBG_2_RGBG(c)] = get2();
+        if (cam_mul[0] > 0.001f) Got_AsShotWB = 1;
+      }
+    }
+    else if (type == 0x10a9) // ColorBalance: Canon D60, 10D, 300D, and clones
+    {
+      int bls = 0;
+/*
+      int table[] = {
+          LIBRAW_WBI_Auto,     // 0
+          LIBRAW_WBI_Daylight, // 1
+          LIBRAW_WBI_Cloudy,   // 2
+          LIBRAW_WBI_Tungsten, // 3
+          LIBRAW_WBI_FL_W,     // 4
+          LIBRAW_WBI_Flash,    // 5
+          LIBRAW_WBI_Custom,   // 6, absent in Canon D60
+          LIBRAW_WBI_Auto,     // 7, use this if camera is set to b/w JPEG
+          LIBRAW_WBI_Shade,    // 8
+          LIBRAW_WBI_Kelvin    // 9, absent in Canon D60
+      };
+*/
+      int nWB =
+          ((get2() - 2) / 8) -
+          1; // 2 bytes this, N recs 4*2bytes each, last rec is black level
+      if (nWB)
+        FORC4 icWBC[LIBRAW_WBI_Auto][RGGB_2_RGBG(c)] = get2();
+      if (nWB >= 7)
+        Canon_WBpresets(0, 0);
+      else
+        FORC4 cam_mul[c] = icWBC[LIBRAW_WBI_Auto][c];
+      if (nWB == 7) // mostly Canon EOS D60 + some fw#s for 300D;
+                    // check for 0x1668000 is unreliable
+      {
+        if ((wbi >= 0) && (wbi < 9) && (wbi != 6))
+        {
+          FORC4 cam_mul[c] = icWBC[Canon_wbi2std[wbi]][c];
+        }
+        else
+        {
+          FORC4 cam_mul[c] = icWBC[LIBRAW_WBI_Auto][c];
+        }
+      }
+      else if (nWB == 9) // Canon 10D, 300D
+      {
+        FORC4 icWBC[LIBRAW_WBI_Custom][RGGB_2_RGBG(c)] = get2();
+        FORC4 icWBC[LIBRAW_WBI_Kelvin][RGGB_2_RGBG(c)] = get2();
+        if ((wbi >= 0) && (wbi < 10))
+        {
+          FORC4 cam_mul[c] = icWBC[Canon_wbi2std[wbi]][c];
+        }
+        else
+        {
+          FORC4 cam_mul[c] = icWBC[LIBRAW_WBI_Auto][c];
+        }
+      }
+      FORC4
+      bls += (imCanon.ChannelBlackLevel[RGGB_2_RGBG(c)] = get2());
+      imCanon.AverageBlackLevel = bls / 4;
+    }
+    else if (type == 0x102d)
+    {
+      Canon_CameraSettings(len >> 1);
+    }
+
+    else if (type == 0x10b4) {
+      switch (get2()) {
+      case 1:
+        imCommon.ColorSpace = LIBRAW_COLORSPACE_sRGB;
+        break;
+      case 2:
+        imCommon.ColorSpace = LIBRAW_COLORSPACE_AdobeRGB;
+        break;
+      default:
+        imCommon.ColorSpace = LIBRAW_COLORSPACE_Unknown;
+        break;
+      }
+
+    } else if (type == 0x580b)
+    {
+      if (strcmp(model, "Canon EOS D30"))
+        sprintf(imgdata.shootinginfo.BodySerial, "%d", len);
+      else
+        sprintf(imgdata.shootinginfo.BodySerial, "%0x-%05d", len >> 16,
+                len & 0xffff);
+    }
+    else if (type == 0x0032) // CanonColorInfo1
+    {
+      if (len == 768) { // EOS D30
+
+        ushort q;
+        fseek(ifp, 4, SEEK_CUR);
+        for (int linenum = 0; linenum < Canon_D30_linenums_2_StdWBi.size(); linenum++) {
+          if (Canon_D30_linenums_2_StdWBi[linenum] != LIBRAW_WBI_Unknown) {
+            FORC4 {
+              q = get2();
+              icWBC[Canon_D30_linenums_2_StdWBi[linenum]][RGGB_2_RGBG(c)] =
+                (int)(roundf(1024000.0f / (float)MAX(1, q)));
+            }
+//         if (Canon_wbi2std[imCanon.wbi] == *(Canon_D30_linenums_2_StdWBi + linenum)) {
+//           FORC4 cam_mul[c] = icWBC[*(Canon_D30_linenums_2_StdWBi + linenum)][c];
+//           Got_AsShotWB = 1;
+//           }
+          }
+        }
+        fseek (ifp, 68-Canon_D30_linenums_2_StdWBi.size()*8, SEEK_CUR);
+
+        FORC4 {
+          q = get2();
+          cam_mul[RGGB_2_RGBG(c)] = 1024.0 / MAX(1, q);
+        }
+        if (!wbi)
+          cam_mul[0] = -1; // use my auto white balance
+
+      }
+      else if ((cam_mul[0] <= 0.001f) || // Pro1, G3, G5, G6, S45, S50, S60, S70
+               Appendix_A)               // G2, S30, S40
+      {
+        libraw_static_table_t linenums_2_StdWBi;
+        int AsShotWB_linenum = Canon_wbi2std.size();
+
+        CanonColorInfo1_key = get2();
+        if ((CanonColorInfo1_key == key[0]) && (len == 2048)) { // Pro1
+          linenums_2_StdWBi = Canon_KeyIs0x0410_Len2048_linenums_2_StdWBi;
+          WB_table_offset = 8;
+
+        } else if ((CanonColorInfo1_key == key[0]) && (len == 3072)) { // S60, S70, G6
+          linenums_2_StdWBi = Canon_KeyIs0x0410_Len3072_linenums_2_StdWBi;
+          WB_table_offset = 16;
+
+        } else if (!CanonColorInfo1_key && (len == 2048)) { // G2, S30, S40; S45, S50, G3, G5
+          key[0] = key[1] = 0;
+          linenums_2_StdWBi = Canon_KeyIsZero_Len2048_linenums_2_StdWBi;
+          if (imCanon.firmware < 1.02f)
+            UseWBfromTable_as_AsShot = 0;
+
+        } else goto next_tag;
+
+        if ((Canon_wbi2std[wbi] == LIBRAW_WBI_Auto)    ||
+            (Canon_wbi2std[wbi] == LIBRAW_WBI_Unknown) ||
+            Got_AsShotWB)
+          UseWBfromTable_as_AsShot = 0;
+
+        if (UseWBfromTable_as_AsShot) {
+          int temp_wbi;
+          if (Canon_wbi2std[wbi] == LIBRAW_WBI_Custom) temp_wbi = LIBRAW_WBI_Daylight;
+          else temp_wbi = wbi;
+          for (AsShotWB_linenum = 0; AsShotWB_linenum < linenums_2_StdWBi.size(); AsShotWB_linenum++) {
+            if (Canon_wbi2std[temp_wbi] == linenums_2_StdWBi[AsShotWB_linenum]) {
+              break;
+            }
+          }
+        }
+
+        fseek (ifp, 78+WB_table_offset, SEEK_CUR);
+        for (int linenum = 0; linenum < linenums_2_StdWBi.size(); linenum++) {
+          if (linenums_2_StdWBi[linenum] != LIBRAW_WBI_Unknown) {
+            FORC4 icWBC[linenums_2_StdWBi[linenum]][GRBG_2_RGBG(c)] = get2() ^ key[c & 1];
+            if (UseWBfromTable_as_AsShot && (AsShotWB_linenum == linenum)) {
+              FORC4 cam_mul[c] = icWBC[linenums_2_StdWBi[linenum]][c];
+              Got_AsShotWB = 1;
+            }
+          } else {
+            fseek(ifp, 8, SEEK_CUR);
+          }
+        }
+        if (!Got_AsShotWB)
+          cam_mul[0] = -1;
+      }
+    }
+    else if (type == 0x1030 && wbi >= 0 && (0x18040 >> wbi & 1))
+    {
+      ciff_block_1030(); // all that don't have 0x10a9
+    }
+    else if (type == 0x1031)
+    {
+			raw_width = imCanon.SensorWidth = (get2(), get2());
+			raw_height = imCanon.SensorHeight = get2();
+			imCanon.SensorLeftBorder = (get2(), get2(), get2());
+			imCanon.SensorTopBorder = get2();
+			imCanon.SensorRightBorder = get2();
+			imCanon.SensorBottomBorder = get2();
+			imCanon.BlackMaskLeftBorder = get2();
+			imCanon.BlackMaskTopBorder = get2();
+			imCanon.BlackMaskRightBorder = get2();
+			imCanon.BlackMaskBottomBorder = get2();
+    }
+    else if (type == 0x501c)
+    {
+      iso_speed = len & 0xffff;
+    }
+    else if (type == 0x5029)
+    {
+      ilm.CurFocal = len >> 16;
+      ilm.FocalType = len & 0xffff;
+      if (ilm.FocalType == LIBRAW_FT_ZOOM_LENS)
+      {
+        ilm.FocalUnits = 32;
+        if (ilm.FocalUnits > 1)
+          ilm.CurFocal /= (float)ilm.FocalUnits;
+      }
+      focal_len = ilm.CurFocal;
+    }
+    else if (type == 0x5813)
+    {
+      flash_used = int_to_float(len);
+    }
+    else if (type == 0x5814)
+    {
+      canon_ev = int_to_float(len);
+    }
+    else if (type == 0x5817)
+    {
+      shot_order = len;
+    }
+    else if (type == 0x5834)
+    {
+      unique_id = ((unsigned long long)len << 32) >> 32;
+      setCanonBodyFeatures(unique_id);
+    }
+    else if (type == 0x580e)
+    {
+      timestamp = len;
+    }
+    else if (type == 0x180e)
+    {
+      timestamp = get4();
+    }
+
+next_tag:;
+#ifdef LOCALTIME
+    if ((type | 0x4000) == 0x580e)
+      timestamp = mktime(gmtime(&timestamp));
+#endif
+    fseek(ifp, save, SEEK_SET);
+  }
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/metadata/cr3_parser.cpp libkdcraw/libkdcraw/libraw/src/metadata/cr3_parser.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/metadata/cr3_parser.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/metadata/cr3_parser.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,539 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+void LibRaw::selectCRXTrack(short maxTrack)
+{
+  if (maxTrack < 0)
+    return;
+  INT64 bitcounts[LIBRAW_CRXTRACKS_MAXCOUNT], maxbitcount = 0;
+  uint32_t maxjpegbytes = 0;
+  memset(bitcounts, 0, sizeof(bitcounts));
+  for (int i = 0; i <= maxTrack && i < LIBRAW_CRXTRACKS_MAXCOUNT; i++)
+  {
+    crx_data_header_t *d = &libraw_internal_data.unpacker_data.crx_header[i];
+    if (d->MediaType == 1) // RAW
+    {
+      bitcounts[i] = INT64(d->nBits) * INT64(d->f_width) * INT64(d->f_height);
+      if (bitcounts[i] > maxbitcount)
+        maxbitcount = bitcounts[i];
+    }
+    else if (d->MediaType == 2) // JPEG
+    {
+      if (d->MediaSize > maxjpegbytes)
+      {
+        maxjpegbytes = d->MediaSize;
+        thumb_offset = d->MediaOffset;
+        thumb_length = d->MediaSize;
+      }
+    }
+  }
+  if (maxbitcount < 8)
+    return;
+  int framei = -1, framecnt = 0;
+  for (int i = 0; i <= maxTrack && i < LIBRAW_CRXTRACKS_MAXCOUNT; i++)
+  {
+    if (bitcounts[i] == maxbitcount)
+    {
+      if (framecnt <= (int)shot_select)
+        framei = i;
+      framecnt++;
+    }
+  }
+  is_raw = framecnt;
+  if (framei >= 0 && framei < LIBRAW_CRXTRACKS_MAXCOUNT)
+  {
+    crx_data_header_t *d =
+        &libraw_internal_data.unpacker_data.crx_header[framei];
+    data_offset = d->MediaOffset;
+    data_size = d->MediaSize;
+    raw_width = d->f_width;
+    raw_height = d->f_height;
+    load_raw = &LibRaw::crxLoadRaw;
+    switch (d->cfaLayout)
+    {
+    case 0:
+      filters = 0x94949494;
+      break;
+    case 1:
+      filters = 0x61616161;
+      break;
+    case 2:
+      filters = 0x49494949;
+      break;
+    case 3:
+      filters = 0x16161616;
+      break;
+    }
+
+    libraw_internal_data.unpacker_data.crx_track_selected = framei;
+
+    int tiff_idx = -1;
+    INT64 tpixels = 0;
+    for (unsigned i = 0; i < tiff_nifds && i < LIBRAW_IFD_MAXCOUNT; i++)
+      if (INT64(tiff_ifd[i].t_height) * INT64(tiff_ifd[i].t_height) > tpixels)
+      {
+        tpixels = INT64(tiff_ifd[i].t_height) * INT64(tiff_ifd[i].t_height);
+        tiff_idx = i;
+      }
+    if (tiff_idx >= 0)
+      flip = tiff_ifd[tiff_idx].t_flip;
+  }
+}
+
+#define bad_hdr                                                                \
+  (((order != 0x4d4d) && (order != 0x4949)) || (get2() != 0x002a) ||           \
+   (get4() != 0x00000008))
+int LibRaw::parseCR3(unsigned long long oAtomList,
+                     unsigned long long szAtomList, short &nesting,
+                     char *AtomNameStack, short &nTrack, short &TrackType)
+{
+  /*
+  Atom starts with 4 bytes for Atom size and 4 bytes containing Atom name
+  Atom size includes the length of the header and the size of all "contained"
+  Atoms if Atom size == 1, Atom has the extended size stored in 8 bytes located
+  after the Atom name if Atom size == 0, it is the last top-level Atom extending
+  to the end of the file Atom name is often a 4 symbol mnemonic, but can be a
+  4-byte integer
+  */
+  const char UIID_Canon[17] =
+      "\x85\xc0\xb6\x87\x82\x0f\x11\xe0\x81\x11\xf4\xce\x46\x2b\x6a\x48";
+
+  /*
+  AtomType = 0 - unknown: "unk."
+  AtomType = 1 - container atom: "cont"
+  AtomType = 2 - leaf atom: "leaf"
+  AtomType = 3 - can be container, can be leaf: "both"
+  */
+  short AtomType;
+  static const struct
+  {
+    char AtomName[5];
+    short AtomType;
+  } AtomNamesList[] = {
+      {"dinf", 1},
+      {"edts", 1},
+      {"fiin", 1},
+      {"ipro", 1},
+      {"iprp", 1},
+      {"mdia", 1},
+      {"meco", 1},
+      {"mere", 1},
+      {"mfra", 1},
+      {"minf", 1},
+      {"moof", 1},
+      {"moov", 1},
+      {"mvex", 1},
+      {"paen", 1},
+      {"schi", 1},
+      {"sinf", 1},
+      {"skip", 1},
+      {"stbl", 1},
+      {"stsd", 1},
+      {"strk", 1},
+      {"tapt", 1},
+      {"traf", 1},
+      {"trak", 1},
+
+      {"cdsc", 2},
+      {"colr", 2},
+      {"dimg", 2},
+      // {"dref", 2},
+      {"free", 2},
+      {"frma", 2},
+      {"ftyp", 2},
+      {"hdlr", 2},
+      {"hvcC", 2},
+      {"iinf", 2},
+      {"iloc", 2},
+      {"infe", 2},
+      {"ipco", 2},
+      {"ipma", 2},
+      {"iref", 2},
+      {"irot", 2},
+      {"ispe", 2},
+      {"meta", 2},
+      {"mvhd", 2},
+      {"pitm", 2},
+      {"pixi", 2},
+      {"schm", 2},
+      {"thmb", 2},
+      {"tkhd", 2},
+      {"url ", 2},
+      {"urn ", 2},
+
+      {"CCTP", 1},
+      {"CRAW", 1},
+
+      {"JPEG", 2},
+      {"CDI1", 2},
+      {"CMP1", 2},
+
+      {"CNCV", 2},
+      {"CCDT", 2},
+      {"CTBO", 2},
+      {"CMT1", 2},
+      {"CMT2", 2},
+      {"CMT3", 2},
+      {"CMT4", 2},
+      {"THMB", 2},
+      {"co64", 2},
+      {"mdat", 2},
+      {"mdhd", 2},
+      {"nmhd", 2},
+      {"stsc", 2},
+      {"stsz", 2},
+      {"stts", 2},
+      {"vmhd", 2},
+
+      {"dref", 3},
+      {"uuid", 3},
+  };
+
+  const char sHandlerType[5][5] = {"unk.", "soun", "vide", "hint", "meta"};
+
+  int c, err;
+
+  ushort tL;                        // Atom length represented in 4 or 8 bytes
+  char nmAtom[5];                   // Atom name
+  unsigned long long oAtom, szAtom; // Atom offset and Atom size
+  unsigned long long oAtomContent,
+      szAtomContent; // offset and size of Atom content
+  unsigned long long lHdr;
+
+  char UIID[16];
+  uchar CMP1[36];
+  char HandlerType[5], MediaFormatID[5];
+  uint32_t relpos_inDir, relpos_inBox;
+  unsigned szItem, Tag, lTag;
+  ushort tItem;
+
+  nmAtom[0] = MediaFormatID[0] = nmAtom[4] = MediaFormatID[4] = '\0';
+  strcpy(HandlerType, sHandlerType[0]);
+  oAtom = oAtomList;
+  nesting++;
+  if (nesting > 31)
+    return -14; // too deep nesting
+  short s_order = order;
+
+  while ((oAtom + 8ULL) <= (oAtomList + szAtomList))
+  {
+    lHdr = 0ULL;
+    err = 0;
+    order = 0x4d4d;
+    fseek(ifp, oAtom, SEEK_SET);
+    szAtom = get4();
+    FORC4 nmAtom[c] = AtomNameStack[nesting * 4 + c] = fgetc(ifp);
+    AtomNameStack[(nesting + 1) * 4] = '\0';
+    tL = 4;
+    AtomType = 0;
+
+    for (c = 0; c < int(sizeof AtomNamesList / sizeof *AtomNamesList); c++)
+      if (!strcmp(nmAtom, AtomNamesList[c].AtomName))
+      {
+        AtomType = AtomNamesList[c].AtomType;
+        break;
+      }
+
+    if (!AtomType)
+    {
+      err = 1;
+    }
+
+    if (szAtom == 0ULL)
+    {
+      if (nesting != 0)
+      {
+        err = -2;
+        goto fin;
+      }
+      szAtom = szAtomList - oAtom;
+      oAtomContent = oAtom + 8ULL;
+      szAtomContent = szAtom - 8ULL;
+    }
+    else if (szAtom == 1ULL)
+    {
+      if ((oAtom + 16ULL) > (oAtomList + szAtomList))
+      {
+        err = -3;
+        goto fin;
+      }
+      tL = 8;
+      szAtom = (((unsigned long long)get4()) << 32) | get4();
+      oAtomContent = oAtom + 16ULL;
+      szAtomContent = szAtom - 16ULL;
+    }
+    else
+    {
+      oAtomContent = oAtom + 8ULL;
+      szAtomContent = szAtom - 8ULL;
+    }
+
+    if (!strcmp(nmAtom, "trak"))
+    {
+      nTrack++;
+      TrackType = 0;
+      if (nTrack >= LIBRAW_CRXTRACKS_MAXCOUNT)
+        break;
+    }
+    if (!strcmp(AtomNameStack, "moovuuid"))
+    {
+      lHdr = 16ULL;
+      fread(UIID, 1, lHdr, ifp);
+      if (!strncmp(UIID, UIID_Canon, lHdr))
+      {
+        AtomType = 1;
+      }
+      else
+        fseek(ifp, -lHdr, SEEK_CUR);
+    }
+    else if (!strcmp(AtomNameStack, "moovuuidCCTP"))
+    {
+      lHdr = 12ULL;
+    }
+    else if (!strcmp(AtomNameStack, "moovuuidCMT1"))
+    {
+      short q_order = order;
+      order = get2();
+      if ((tL != 4) || bad_hdr)
+      {
+        err = -4;
+        goto fin;
+      }
+      parse_tiff_ifd(oAtomContent);
+      order = q_order;
+    }
+    else if (!strcmp(AtomNameStack, "moovuuidCMT2"))
+    {
+      short q_order = order;
+      order = get2();
+      if ((tL != 4) || bad_hdr)
+      {
+        err = -5;
+        goto fin;
+      }
+      parse_exif(oAtomContent);
+      order = q_order;
+    }
+    else if (!strcmp(AtomNameStack, "moovuuidCMT3"))
+    {
+      short q_order = order;
+      order = get2();
+      if ((tL != 4) || bad_hdr)
+      {
+        err = -6;
+        goto fin;
+      }
+      fseek(ifp, -12L, SEEK_CUR);
+      parse_makernote(oAtomContent, 0);
+      order = q_order;
+    }
+    else if (!strcmp(AtomNameStack, "moovuuidCMT4"))
+    {
+      short q_order = order;
+      order = get2();
+      if ((tL != 4) || bad_hdr)
+      {
+        err = -6;
+        goto fin;
+      }
+      INT64 off = ftell(ifp);
+      parse_gps(oAtomContent);
+      fseek(ifp, off, SEEK_SET);
+      parse_gps_libraw(oAtomContent);
+      order = q_order;
+    }
+    else if (!strcmp(AtomNameStack, "moovtrakmdiahdlr"))
+    {
+      fseek(ifp, 8L, SEEK_CUR);
+      FORC4 HandlerType[c] = fgetc(ifp);
+      for (c = 1; c < int(sizeof sHandlerType / sizeof *sHandlerType); c++)
+        if (!strcmp(HandlerType, sHandlerType[c]))
+        {
+          TrackType = c;
+          break;
+        }
+    }
+    else if (!strcmp(AtomNameStack, "moovtrakmdiaminfstblstsd"))
+    {
+      if (szAtomContent >= 16)
+      {
+        fseek(ifp, 12L, SEEK_CUR);
+        lHdr = 8;
+      }
+      else
+      {
+        err = -7;
+        goto fin;
+      }
+      FORC4 MediaFormatID[c] = fgetc(ifp);
+      if ((TrackType == 2) && (!strcmp(MediaFormatID, "CRAW")))
+      {
+        if (szAtomContent >= 44)
+          fseek(ifp, 24L, SEEK_CUR);
+        else
+        {
+          err = -8;
+          goto fin;
+        }
+      }
+      else
+      {
+        AtomType = 2; // only continue for CRAW
+        lHdr = 0;
+      }
+#define current_track libraw_internal_data.unpacker_data.crx_header[nTrack]
+
+      /*ImageWidth =*/ get2();
+      /*ImageHeight =*/ get2();
+    }
+    else if (!strcmp(AtomNameStack, "moovtrakmdiaminfstblstsdCRAW"))
+    {
+      lHdr = 82;
+    }
+    else if (!strcmp(AtomNameStack, "moovtrakmdiaminfstblstsdCRAWCMP1"))
+    {
+      if (szAtomContent >= 40)
+        fread(CMP1, 1, 36, ifp);
+      else
+      {
+        err = -7;
+        goto fin;
+      }
+      if (!crxParseImageHeader(CMP1, nTrack))
+        current_track.MediaType = 1;
+    }
+    else if (!strcmp(AtomNameStack, "moovtrakmdiaminfstblstsdCRAWJPEG"))
+    {
+      current_track.MediaType = 2;
+    }
+    else if (!strcmp(AtomNameStack, "moovtrakmdiaminfstblstsz"))
+    {
+      if (szAtomContent == 12)
+        fseek(ifp, 4L, SEEK_CUR);
+      else if (szAtomContent == 16)
+        fseek(ifp, 12L, SEEK_CUR);
+      else
+      {
+        err = -9;
+        goto fin;
+      }
+      current_track.MediaSize = get4();
+    }
+    else if (!strcmp(AtomNameStack, "moovtrakmdiaminfstblco64"))
+    {
+      if (szAtomContent == 16)
+        fseek(ifp, 8L, SEEK_CUR);
+      else
+      {
+        err = -10;
+        goto fin;
+      }
+      current_track.MediaOffset = (((unsigned long long)get4()) << 32) | get4();
+    }
+
+    if (nTrack >= 0 && nTrack < LIBRAW_CRXTRACKS_MAXCOUNT &&
+        current_track.MediaSize && current_track.MediaOffset &&
+        ((oAtom + szAtom) >= (oAtomList + szAtomList)) &&
+        !strncmp(AtomNameStack, "moovtrakmdiaminfstbl", 20))
+    {
+      if ((TrackType == 4) && (!strcmp(MediaFormatID, "CTMD")))
+      {
+        order = 0x4949;
+        relpos_inDir = 0L;
+        while (relpos_inDir + 6 < current_track.MediaSize)
+        {
+          if (current_track.MediaOffset + relpos_inDir > ifp->size() - 6) // need at least 6 bytes
+          {
+              err = -11;
+              goto fin;
+          }
+          fseek(ifp, current_track.MediaOffset + relpos_inDir, SEEK_SET);
+          szItem = get4();
+          tItem = get2();
+          if (szItem < 1 || (  (relpos_inDir + szItem) > current_track.MediaSize))
+          {
+            err = -11;
+            goto fin;
+          }
+          if ((tItem == 7) || (tItem == 8) || (tItem == 9))
+          {
+            relpos_inBox = relpos_inDir + 12L;
+            while (relpos_inBox + 8 < relpos_inDir + szItem)
+            {
+              if (current_track.MediaOffset + relpos_inBox > ifp->size() - 8) // need at least 8 bytes
+              {
+                  err = -11;
+                  goto fin;
+              }
+              fseek(ifp, current_track.MediaOffset + relpos_inBox, SEEK_SET);
+              lTag = get4();
+              Tag = get4();
+              if (lTag < 8)
+              {
+                err = -12;
+                goto fin;
+              }
+              else if ((relpos_inBox + lTag) > (relpos_inDir + szItem))
+              {
+                err = -11;
+                goto fin;
+              }
+              if ((Tag == 0x927c) && ((tItem == 7) || (tItem == 8)))
+              {
+                fseek(ifp, current_track.MediaOffset + relpos_inBox + 8L,
+                      SEEK_SET);
+                short q_order = order;
+                order = get2();
+                if (bad_hdr)
+                {
+                  err = -13;
+                  goto fin;
+                }
+                fseek(ifp, -8L, SEEK_CUR);
+                libraw_internal_data.unpacker_data.CR3_CTMDtag = 1;
+                parse_makernote(current_track.MediaOffset + relpos_inBox + 8,
+                                0);
+                libraw_internal_data.unpacker_data.CR3_CTMDtag = 0;
+                order = q_order;
+              }
+              relpos_inBox += lTag;
+            }
+          }
+          relpos_inDir += szItem;
+        }
+        order = 0x4d4d;
+      }
+    }
+#undef current_track
+    if (AtomType == 1)
+    {
+      err = parseCR3(oAtomContent + lHdr, szAtomContent - lHdr, nesting,
+                     AtomNameStack, nTrack, TrackType);
+      if (err)
+        goto fin;
+    }
+    oAtom += szAtom;
+  }
+
+fin:
+  nesting--;
+  if (nesting >= 0)
+    AtomNameStack[nesting * 4] = '\0';
+  order = s_order;
+  return err;
+}
+#undef bad_hdr
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/metadata/epson.cpp libkdcraw/libkdcraw/libraw/src/metadata/epson.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/metadata/epson.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/metadata/epson.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,96 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+void LibRaw::parseEpsonMakernote(int base, int uptag, unsigned dng_writer)
+{
+
+#define isRIC imgdata.sizes.raw_inset_crop
+
+  unsigned entries, tag, type, len, save;
+  short morder, sorder = order;
+  ushort c;
+  INT64 fsize = ifp->size();
+
+  fseek(ifp, -2, SEEK_CUR);
+
+  entries = get2();
+  if (entries > 1000)
+    return;
+  morder = order;
+
+  while (entries--)
+  {
+    order = morder;
+    tiff_get(base, &tag, &type, &len, &save);
+    INT64 pos = ifp->tell();
+    if (len > 8 && pos + len > 2 * fsize)
+    {
+      fseek(ifp, save, SEEK_SET); // Recover tiff-read position!!
+      continue;
+    }
+
+    tag |= uptag << 16;
+    if (len > 100 * 1024 * 1024)
+      goto next; // 100Mb tag? No!
+
+    if (tag == 0x020b)
+    {
+      if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_LONG))
+        isRIC.cwidth = get4();
+      else if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_SHORT))
+        isRIC.cwidth = get2();
+    }
+    else if (tag == 0x020c)
+    {
+      if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_LONG))
+        isRIC.cheight = get4();
+      else if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_SHORT))
+        isRIC.cheight = get2();
+    }
+    else if (tag == 0x0400)
+    {                                 // sensor area
+      ushort sdims[4] = {0, 0, 0, 0}; // left margin, top margin, width, height
+      FORC4 sdims[c] = get2();
+      isRIC.cleft = (sdims[2] - sdims[0] - isRIC.cwidth) / 2;
+      isRIC.ctop = (sdims[3] - sdims[1] - isRIC.cheight) / 2;
+    }
+
+    if (dng_writer == nonDNG)
+    {
+
+      if (tag == 0x0280)
+      {
+        thumb_offset = ftell(ifp);
+        thumb_length = len;
+      }
+      else if (tag == 0x0401)
+      {
+        FORC4 cblack[RGGB_2_RGBG(c)] = get4();
+      }
+      else if (tag == 0x0e80)
+      {
+        fseek(ifp, 48, SEEK_CUR);
+        cam_mul[0] = get2() * 567.0 / 0x10000;
+        cam_mul[2] = get2() * 431.0 / 0x10000;
+      }
+    }
+
+  next:
+    fseek(ifp, save, SEEK_SET);
+  }
+  order = sorder;
+#undef isRIC
+}
